/* -*- buffer-read-only: t -*- vi: set ro:
#line 636
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 636
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 15 "msg.bi"
/* This file is part of Mailfromd.             -*- c -*-
#line 15
   Copyright (C) 2008, 2010-2011 Sergey Poznyakoff
#line 15

#line 15
   This program is free software; you can redistribute it and/or modify
#line 15
   it under the terms of the GNU General Public License as published by
#line 15
   the Free Software Foundation; either version 3, or (at your option)
#line 15
   any later version.
#line 15

#line 15
   This program is distributed in the hope that it will be useful,
#line 15
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 15
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 15
   GNU General Public License for more details.
#line 15

#line 15
   You should have received a copy of the GNU General Public License
#line 15
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static size_t nmsgs = NMSGS;

static struct mu_cfg_param msg_cfg_param[] = {
	{ "max-open-messages", mu_cfg_size, &nmsgs, 0, NULL,
	  N_("Maximum number of messages to open simultaneously.") },
	{ NULL }
};

static void *
alloc_msgs()
{
	return xcalloc(nmsgs, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + nmsgs; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].current) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 56

#line 56
static int MSGTAB_id;
#line 56 "msg.bi"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 131


#line 142


#line 153


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 158
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 158
	struct mf_message *mp;
#line 158
			
#line 158
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 158
			env_throw_bi(env, mfe_range, NULL, _("invalid message descriptor"))
#line 158
;
#line 158
	mp = mtab + nmsg;
#line 158
		if (!(mp->msg))
#line 158
			env_throw_bi(env, mfe_failure, NULL, _("message not open"))
#line 158

#line 158
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 163
bi_message_close(eval_environ_t env)
#line 163

#line 163 "msg.bi"
{
#line 163
	
#line 163

#line 163

#line 163
long  nmsg;
#line 163
        
#line 163
get_numeric_arg(env, 0, &nmsg);
#line 163
        
#line 163

#line 163
        adjust_stack(env, 1);
#line 163

#line 163
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 163
		prog_trace(env, "message_close %lu",nmsg);;
#line 163

{
	
#line 165
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 165
	struct mf_message *mp;
#line 165
			
#line 165
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 165
			env_throw_bi(env, mfe_range, "message_close", _("invalid message descriptor"))
#line 165
;
#line 165
	mp = mtab + nmsg;
#line 165
		if (!(mp->msg))
#line 165
			env_throw_bi(env, mfe_failure, "message_close", _("message not open"))
#line 165

#line 165
;
	bi_close_message(mp);
}
}

/* number message_size(number nmsg) */
void
#line 171
bi_message_size(eval_environ_t env)
#line 171

#line 171 "msg.bi"
{
#line 171
	
#line 171

#line 171

#line 171
long  nmsg;
#line 171
        
#line 171
get_numeric_arg(env, 0, &nmsg);
#line 171
        
#line 171

#line 171
        adjust_stack(env, 1);
#line 171

#line 171
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 171
		prog_trace(env, "message_size %lu",nmsg);;
#line 171

{
	int rc;
	size_t size;
	
#line 175
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 175
	struct mf_message *mp;
#line 175
			
#line 175
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 175
			env_throw_bi(env, mfe_range, "message_size", _("invalid message descriptor"))
#line 175
;
#line 175
	mp = mtab + nmsg;
#line 175
		if (!(mp->msg))
#line 175
			env_throw_bi(env, mfe_failure, "message_size", _("message not open"))
#line 175

#line 175
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 178
			env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 180
;
		if (!(size < LONG_MAX))
#line 181
			env_throw_bi(env, mfe_range, "message_size", _("message size out of representable range"))
#line 183
;
	
#line 184
do {
#line 184
  push(env, (STKVAL) ((long)size));
#line 184
  return;
#line 184
} while (0);
}	
}

/* number message_lines(number nmsg) */
void
#line 189
bi_message_lines(eval_environ_t env)
#line 189

#line 189 "msg.bi"
{
#line 189
	
#line 189

#line 189

#line 189
long  nmsg;
#line 189
        
#line 189
get_numeric_arg(env, 0, &nmsg);
#line 189
        
#line 189

#line 189
        adjust_stack(env, 1);
#line 189

#line 189
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 189
		prog_trace(env, "message_lines %lu",nmsg);;
#line 189

{
	int rc;
	size_t lines;
	
#line 193
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 193
	struct mf_message *mp;
#line 193
			
#line 193
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 193
			env_throw_bi(env, mfe_range, "message_lines", _("invalid message descriptor"))
#line 193
;
#line 193
	mp = mtab + nmsg;
#line 193
		if (!(mp->msg))
#line 193
			env_throw_bi(env, mfe_failure, "message_lines", _("message not open"))
#line 193

#line 193
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 196
			env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 199
;
	
#line 200
do {
#line 200
  push(env, (STKVAL) (lines));
#line 200
  return;
#line 200
} while (0);
}
}

/* number message_body_size(number nmsg) */
void
#line 205
bi_message_body_size(eval_environ_t env)
#line 205

#line 205 "msg.bi"
{
#line 205
	
#line 205

#line 205

#line 205
long  nmsg;
#line 205
        
#line 205
get_numeric_arg(env, 0, &nmsg);
#line 205
        
#line 205

#line 205
        adjust_stack(env, 1);
#line 205

#line 205
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 205
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 205

{
	int rc;
	size_t size;
	
#line 209
	
#line 209
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 209
	struct mf_message *mp;
#line 209
			
#line 209
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 209
			env_throw_bi(env, mfe_range, "message_body_size", _("invalid message descriptor"))
#line 209
;
#line 209
	mp = mtab + nmsg;
#line 209
		if (!(mp->msg))
#line 209
			env_throw_bi(env, mfe_failure, "message_body_size", _("message not open"))
#line 209

#line 209
;
#line 209
	if (!mp->body) {
#line 209
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 209
			if (!(rc == 0))
#line 209
			env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 209
;
#line 209
	}	  
#line 209
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 212
			env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 214
;
		if (!(size < LONG_MAX))
#line 215
			env_throw_bi(env, mfe_range, "message_body_size", _("body size out of representable range"))
#line 217
;
	
#line 218
do {
#line 218
  push(env, (STKVAL) ((long)size));
#line 218
  return;
#line 218
} while (0);
}
}

/* number message_body_lines(number nmsg) */
void
#line 223
bi_message_body_lines(eval_environ_t env)
#line 223

#line 223 "msg.bi"
{
#line 223
	
#line 223

#line 223

#line 223
long  nmsg;
#line 223
        
#line 223
get_numeric_arg(env, 0, &nmsg);
#line 223
        
#line 223

#line 223
        adjust_stack(env, 1);
#line 223

#line 223
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 223
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 223

{
	int rc;
	size_t lines;
	
#line 227
	
#line 227
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 227
	struct mf_message *mp;
#line 227
			
#line 227
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 227
			env_throw_bi(env, mfe_range, "message_body_lines", _("invalid message descriptor"))
#line 227
;
#line 227
	mp = mtab + nmsg;
#line 227
		if (!(mp->msg))
#line 227
			env_throw_bi(env, mfe_failure, "message_body_lines", _("message not open"))
#line 227

#line 227
;
#line 227
	if (!mp->body) {
#line 227
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 227
			if (!(rc == 0))
#line 227
			env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 227
;
#line 227
	}	  
#line 227
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 230
			env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 233
;
	
#line 234
do {
#line 234
  push(env, (STKVAL) (lines));
#line 234
  return;
#line 234
} while (0);
}
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 242
bi_message_header_size(eval_environ_t env)
#line 242

#line 242 "msg.bi"
{
#line 242
	
#line 242

#line 242

#line 242
long  nmsg;
#line 242
        
#line 242
get_numeric_arg(env, 0, &nmsg);
#line 242
        
#line 242

#line 242
        adjust_stack(env, 1);
#line 242

#line 242
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 242
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 242

{
	int rc;
	size_t size;
	
#line 246
	
#line 246
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 246
	struct mf_message *mp;
#line 246
			
#line 246
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 246
			env_throw_bi(env, mfe_range, "message_header_size", _("invalid message descriptor"))
#line 246
;
#line 246
	mp = mtab + nmsg;
#line 246
		if (!(mp->msg))
#line 246
			env_throw_bi(env, mfe_failure, "message_header_size", _("message not open"))
#line 246

#line 246
;
#line 246
	if (!mp->hdr) {
#line 246
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 246
			if (!(rc == 0))
#line 246
			env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 246
;
#line 246
	}	  
#line 246
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 249
			env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 251
;
		if (!(size < LONG_MAX))
#line 252
			env_throw_bi(env, mfe_range, "message_header_size", _("header size out of representable range"))
#line 254
;
	
#line 255
do {
#line 255
  push(env, (STKVAL) ((long)size));
#line 255
  return;
#line 255
} while (0);
}
}

/* number message_header_lines(number nmsg) */
void
#line 260
bi_message_header_lines(eval_environ_t env)
#line 260

#line 260 "msg.bi"
{
#line 260
	
#line 260

#line 260

#line 260
long  nmsg;
#line 260
        
#line 260
get_numeric_arg(env, 0, &nmsg);
#line 260
        
#line 260

#line 260
        adjust_stack(env, 1);
#line 260

#line 260
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 260
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 260

{
	int rc;
	size_t lines;
	
#line 264
	
#line 264
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 264
	struct mf_message *mp;
#line 264
			
#line 264
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 264
			env_throw_bi(env, mfe_range, "message_header_lines", _("invalid message descriptor"))
#line 264
;
#line 264
	mp = mtab + nmsg;
#line 264
		if (!(mp->msg))
#line 264
			env_throw_bi(env, mfe_failure, "message_header_lines", _("message not open"))
#line 264

#line 264
;
#line 264
	if (!mp->hdr) {
#line 264
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 264
			if (!(rc == 0))
#line 264
			env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 264
;
#line 264
	}	  
#line 264
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 267
			env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 270
;
	
#line 271
do {
#line 271
  push(env, (STKVAL) (lines));
#line 271
  return;
#line 271
} while (0);
}
}

/* number message_header_count(number nmsg) */
void
#line 276
bi_message_header_count(eval_environ_t env)
#line 276

#line 276 "msg.bi"
{
#line 276
	
#line 276

#line 276

#line 276
long  nmsg;
#line 276
        
#line 276
get_numeric_arg(env, 0, &nmsg);
#line 276
        
#line 276

#line 276
        adjust_stack(env, 1);
#line 276

#line 276
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 276
		prog_trace(env, "message_header_count %lu",nmsg);;
#line 276

{
	int rc;
	size_t count;
	
#line 280
	
#line 280
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 280
	struct mf_message *mp;
#line 280
			
#line 280
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 280
			env_throw_bi(env, mfe_range, "message_header_count", _("invalid message descriptor"))
#line 280
;
#line 280
	mp = mtab + nmsg;
#line 280
		if (!(mp->msg))
#line 280
			env_throw_bi(env, mfe_failure, "message_header_count", _("message not open"))
#line 280

#line 280
;
#line 280
	if (!mp->hdr) {
#line 280
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 280
			if (!(rc == 0))
#line 280
			env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 280
;
#line 280
	}	  
#line 280
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 283
			env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 286
;
	
#line 287
do {
#line 287
  push(env, (STKVAL) (count));
#line 287
  return;
#line 287
} while (0);
}
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 292
bi_message_has_header(eval_environ_t env)
#line 292

#line 292 "msg.bi"
{
#line 292
	
#line 292

#line 292
long __bi_argcnt;
#line 292
long  nmsg;
#line 292
        char * header;
#line 292
        long  idx;
#line 292
        
#line 292
get_numeric_arg(env, 1, &nmsg);
#line 292
        get_string_arg(env, 2, &header);
#line 292
        get_numeric_arg(env, 3, &idx);
#line 292
        
#line 292
get_numeric_arg(env, 0, &__bi_argcnt);
#line 292
        adjust_stack(env, __bi_argcnt + 1);
#line 292

#line 292
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 292
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 297
	
#line 297
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 297
	struct mf_message *mp;
#line 297
			
#line 297
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 297
			env_throw_bi(env, mfe_range, "message_has_header", _("invalid message descriptor"))
#line 297
;
#line 297
	mp = mtab + nmsg;
#line 297
		if (!(mp->msg))
#line 297
			env_throw_bi(env, mfe_failure, "message_has_header", _("message not open"))
#line 297

#line 297
;
#line 297
	if (!mp->hdr) {
#line 297
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 297
			if (!(rc == 0))
#line 297
			env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 297
;
#line 297
	}	  
#line 297
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 300
do {
#line 300
  push(env, (STKVAL) (rc == 0));
#line 300
  return;
#line 300
} while (0);
}
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 305
bi_message_find_header(eval_environ_t env)
#line 305

#line 305 "msg.bi"
{
#line 305
	
#line 305

#line 305
long __bi_argcnt;
#line 305
long  nmsg;
#line 305
        char * header;
#line 305
        long  idx;
#line 305
        
#line 305
get_numeric_arg(env, 1, &nmsg);
#line 305
        get_string_arg(env, 2, &header);
#line 305
        get_numeric_arg(env, 3, &idx);
#line 305
        
#line 305
get_numeric_arg(env, 0, &__bi_argcnt);
#line 305
        adjust_stack(env, __bi_argcnt + 1);
#line 305

#line 305
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 305
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 310
	
#line 310
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 310
	struct mf_message *mp;
#line 310
			
#line 310
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 310
			env_throw_bi(env, mfe_range, "message_find_header", _("invalid message descriptor"))
#line 310
;
#line 310
	mp = mtab + nmsg;
#line 310
		if (!(mp->msg))
#line 310
			env_throw_bi(env, mfe_failure, "message_find_header", _("message not open"))
#line 310

#line 310
;
#line 310
	if (!mp->hdr) {
#line 310
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 310
			if (!(rc == 0))
#line 310
			env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 310
;
#line 310
	}	  
#line 310
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "message_find_header", _("header not found"));
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 317
return;
#line 317
} while (0);
}
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 325
bi_message_is_multipart(eval_environ_t env)
#line 325

#line 325 "msg.bi"
{
#line 325
	
#line 325

#line 325

#line 325
long  nmsg;
#line 325
        
#line 325
get_numeric_arg(env, 0, &nmsg);
#line 325
        
#line 325

#line 325
        adjust_stack(env, 1);
#line 325

#line 325
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 325
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 325

{
	int rc, res;
	
#line 328
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 328
	struct mf_message *mp;
#line 328
			
#line 328
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 328
			env_throw_bi(env, mfe_range, "message_is_multipart", _("invalid message descriptor"))
#line 328
;
#line 328
	mp = mtab + nmsg;
#line 328
		if (!(mp->msg))
#line 328
			env_throw_bi(env, mfe_failure, "message_is_multipart", _("message not open"))
#line 328

#line 328
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 331
			env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 334
;
	
#line 335
do {
#line 335
  push(env, (STKVAL) (res));
#line 335
  return;
#line 335
} while (0);
}
}

/* number message_count_parts(number msg) */
void
#line 340
bi_message_count_parts(eval_environ_t env)
#line 340

#line 340 "msg.bi"
{
#line 340
	
#line 340

#line 340

#line 340
long  nmsg;
#line 340
        
#line 340
get_numeric_arg(env, 0, &nmsg);
#line 340
        
#line 340

#line 340
        adjust_stack(env, 1);
#line 340

#line 340
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 340
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 340

{
	int rc;
	size_t count;
	
#line 344
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 344
	struct mf_message *mp;
#line 344
			
#line 344
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 344
			env_throw_bi(env, mfe_range, "message_count_parts", _("invalid message descriptor"))
#line 344
;
#line 344
	mp = mtab + nmsg;
#line 344
		if (!(mp->msg))
#line 344
			env_throw_bi(env, mfe_failure, "message_count_parts", _("message not open"))
#line 344

#line 344
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 346
			env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 349
;
	
#line 350
do {
#line 350
  push(env, (STKVAL) (count));
#line 350
  return;
#line 350
} while (0);
}
}

/* number message_get_part(number msg, number idx) */
void
#line 355
bi_message_get_part(eval_environ_t env)
#line 355

#line 355 "msg.bi"
{
#line 355
	
#line 355

#line 355

#line 355
long  nmsg;
#line 355
        long  idx;
#line 355
        
#line 355
get_numeric_arg(env, 0, &nmsg);
#line 355
        get_numeric_arg(env, 1, &idx);
#line 355
        
#line 355

#line 355
        adjust_stack(env, 2);
#line 355

#line 355
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 355
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 355

{
	int rc;
	mu_message_t msg;
	
#line 359
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 359
	struct mf_message *mp;
#line 359
			
#line 359
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 359
			env_throw_bi(env, mfe_range, "message_get_part", _("invalid message descriptor"))
#line 359
;
#line 359
	mp = mtab + nmsg;
#line 359
		if (!(mp->msg))
#line 359
			env_throw_bi(env, mfe_failure, "message_get_part", _("message not open"))
#line 359

#line 359
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 362
			env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 365
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 367
			env_throw_bi(env, mfe_failure, "message_get_part", _("no more message slots available"))
#line 369
;
	
#line 370
do {
#line 370
  push(env, (STKVAL) (rc));
#line 370
  return;
#line 370
} while (0);
}
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 378
bi_message_rewind(eval_environ_t env)
#line 378

#line 378 "msg.bi"
{
#line 378
	
#line 378

#line 378

#line 378
long  nmsg;
#line 378
        
#line 378
get_numeric_arg(env, 0, &nmsg);
#line 378
        
#line 378

#line 378
        adjust_stack(env, 1);
#line 378

#line 378
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 378
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 378

{
	int rc;
	mu_stream_t str;
	
#line 382
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 382
	struct mf_message *mp;
#line 382
			
#line 382
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 382
			env_throw_bi(env, mfe_range, "message_rewind", _("invalid message descriptor"))
#line 382
;
#line 382
	mp = mtab + nmsg;
#line 382
		if (!(mp->msg))
#line 382
			env_throw_bi(env, mfe_failure, "message_rewind", _("message not open"))
#line 382

#line 382
;
	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 384
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 387
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 389
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 392
;
}
}

/* string message_read_line(number nmsg) */
void
#line 397
bi_message_read_line(eval_environ_t env)
#line 397

#line 397 "msg.bi"
{
#line 397
	
#line 397

#line 397

#line 397
long  nmsg;
#line 397
        
#line 397
get_numeric_arg(env, 0, &nmsg);
#line 397
        
#line 397

#line 397
        adjust_stack(env, 1);
#line 397

#line 397
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 397
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 397

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 402
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 402
	struct mf_message *mp;
#line 402
			
#line 402
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 402
			env_throw_bi(env, mfe_range, "message_read_line", _("invalid message descriptor"))
#line 402
;
#line 402
	mp = mtab + nmsg;
#line 402
		if (!(mp->msg))
#line 402
			env_throw_bi(env, mfe_failure, "message_read_line", _("message not open"))
#line 402

#line 402
;

	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 405
			env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 408
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 410
			env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 413
;
		if (!(size > 0))
#line 414
			env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_sequential_getline: %s",_("end of input"))
#line 417
;
	do {pushs(env, mp->buf);
#line 418
return;
#line 418
} while (0);
}
}

/* string message_body_rewind(number nmsg) */
void
#line 423
bi_message_body_rewind(eval_environ_t env)
#line 423

#line 423 "msg.bi"
{
#line 423
	
#line 423

#line 423

#line 423
long  nmsg;
#line 423
        
#line 423
get_numeric_arg(env, 0, &nmsg);
#line 423
        
#line 423

#line 423
        adjust_stack(env, 1);
#line 423

#line 423
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 423
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 423

{
	int rc;
	mu_stream_t str;
	
#line 427
	
#line 427
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 427
	struct mf_message *mp;
#line 427
			
#line 427
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 427
			env_throw_bi(env, mfe_range, "message_body_rewind", _("invalid message descriptor"))
#line 427
;
#line 427
	mp = mtab + nmsg;
#line 427
		if (!(mp->msg))
#line 427
			env_throw_bi(env, mfe_failure, "message_body_rewind", _("message not open"))
#line 427

#line 427
;
#line 427
	if (!mp->body) {
#line 427
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 427
			if (!(rc == 0))
#line 427
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 427
;
#line 427
	}	  
#line 427
;
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 429
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 432
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 434
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 437
;
}
}

/* string message_read_body_line(number msg)  */
void
#line 442
bi_message_read_body_line(eval_environ_t env)
#line 442

#line 442 "msg.bi"
{
#line 442
	
#line 442

#line 442

#line 442
long  nmsg;
#line 442
        
#line 442
get_numeric_arg(env, 0, &nmsg);
#line 442
        
#line 442

#line 442
        adjust_stack(env, 1);
#line 442

#line 442
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 442
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 442

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 447
	
#line 447
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 447
	struct mf_message *mp;
#line 447
			
#line 447
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 447
			env_throw_bi(env, mfe_range, "message_read_body_line", _("invalid message descriptor"))
#line 447
;
#line 447
	mp = mtab + nmsg;
#line 447
		if (!(mp->msg))
#line 447
			env_throw_bi(env, mfe_failure, "message_read_body_line", _("message not open"))
#line 447

#line 447
;
#line 447
	if (!mp->body) {
#line 447
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 447
			if (!(rc == 0))
#line 447
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 447
;
#line 447
	}	  
#line 447
;
	
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 450
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 453
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 455
			env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 458
;
		if (!(size > 0))
#line 459
			env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_sequential_getline: %s",_("end of input"))
#line 462
;
	do {pushs(env, mp->buf);
#line 463
return;
#line 463
} while (0);
}
}


#line 467
void
#line 467
msg_init_builtin()
#line 467
{
#line 467
        debug_handle = debug_register("bi_msg");
#line 467
	#line 56 "msg.bi"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 56
drop_current_message);
#line 163 "msg.bi"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 171 "msg.bi"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 189 "msg.bi"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 205 "msg.bi"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 223 "msg.bi"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 242 "msg.bi"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 260 "msg.bi"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 276 "msg.bi"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 292 "msg.bi"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 305 "msg.bi"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 325 "msg.bi"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 340 "msg.bi"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 355 "msg.bi"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 378 "msg.bi"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 397 "msg.bi"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 423 "msg.bi"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 442 "msg.bi"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);

#line 467 "msg.bi"
	
#line 467
	 mf_add_runtime_params(msg_cfg_param);
#line 467
	 
#line 467
}
#line 469

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

